//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:19:11
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.CommonLib.Protocol

{
		
		#region Namespace Import Declarations
		
			using System.Collections;
			using System;
			using System.Reflection;
			using System.Runtime.InteropServices;
			
		#endregion
		
	// [DefaultMemberAttribute("Item")]
	[ComVisibleAttribute(false)]
	public class AtObject
	
	{
		
		#region Fields
			private bool m_bProcessCommands;
			private ArrayList m_lstInstructions;
			private int objIndex;
		#endregion
		
		#region Constructors
		
			public AtObject ()
			
			{
				this.m_lstInstructions = new ArrayList ();
				this.objIndex = -1;
				this.m_bProcessCommands = false;
			}
			
		#endregion
		
		#region Properties
		
			public object this[int idx]
			
			{
				get
				{
					if ((idx > -1) && (idx < this.m_lstInstructions.Count))
					{
						return this.m_lstInstructions[idx];
					}
					else
					{
						throw new InvalidOperationException ("[AtObject.get_Item] Index out of range");
					}
				}
				set
				{
					if ((idx > -1) && (idx < this.m_lstInstructions.Count))
					{
						this.m_lstInstructions[idx] = value;
					}
					else if (idx == this.m_lstInstructions.Count)
					{
						int i1 = this.m_lstInstructions.Add (value);
					}
					else
					{
						throw new InvalidOperationException ("[AtObject.set_Item] Index out of range");
					}
				}
			}
			
			
			public int ObjectIndex
			
			{
				get
				{
					return this.objIndex;
				}
				set
				{
					this.objIndex = value;
				}
			}
			
			
			public int Size
			
			{
				get
				{
					if (! this.m_bProcessCommands)
					{
						this.ProcessCommands ();
					}
					int i1 = 0;
					foreach (AtCommand atCommand1 in this.m_lstInstructions)
					{
						i1 += atCommand1.CommandSize;
					}
					return ((i1 + AtCommand.OpcodeSize (LECOpcodes.JobMarker)) + AtCommand.OpcodeSize (LECOpcodes.JobMarker));
				}
			}
			
		#endregion
		
		#region Methods
		
			public int Add (AtCommand poCommand)
			
			{
				return this.m_lstInstructions.Add (poCommand);
			}
			
			private double CalcAngle (short psX1, short psY1, short psX2, short psY2)
			
			{
				double double1 = ((double) (psX2 - psX1));
				double double2 = ((double) (psY2 - psY1));
				double double3 = 0D;
				if (double1 == 0D)
				{
					if (double2 == 0D)
					{
						double3 = 0D;
						return ((double3 * 180D) / Math.PI);
					}
					else if (double2 > 0D)
					{
						double3 = 1.5707963267948966D;
						return ((double3 * 180D) / Math.PI);
					}
					else
					{
						double3 = 4.71238898038469D;
						return ((double3 * 180D) / Math.PI);
					}
				}
				if (double2 == 0D)
				{
					if (double1 > 0D)
					{
						double3 = 0D;
						return ((double3 * 180D) / Math.PI);
					}
					else
					{
						double3 = Math.PI;
						return ((double3 * 180D) / Math.PI);
					}
				}
				if (double1 < 0D)
				{
					double3 = (Math.Atan ((double2 / double1)) + Math.PI);
					return ((double3 * 180D) / Math.PI);
				}
				else if (double2 < 0D)
				{
					double3 = (Math.Atan ((double2 / double1)) + 6.2831853071795862D);
					return ((double3 * 180D) / Math.PI);
				}
				else
				{
					double3 = Math.Atan ((double2 / double1));
					return ((double3 * 180D) / Math.PI);
				}
			}
			
			private double CalcLength (short psX1, short psY1, short psX2, short psY2)
			
			{
				double double1 = Math.Abs (((double) (psX2 - psX1)));
				double double2 = Math.Abs (((double) (psY2 - psY1)));
				if (double1 == 0D)
				{
					return double2;
				}
				else if (double2 != 0D)
				{
					return Math.Sqrt ((Math.Pow (double1, 2D) + Math.Pow (double2, 2D)));
				}
				else
				{
					return double1;
				}
			}
			
			private double CalcScaleDelay (double pdAngle)
			
			{
				if (pdAngle == 0D)
				{
					return 0D;
				}
				else if (pdAngle == 90D)
				{
					return 1D;
				}
				else if (pdAngle != 180D)
				{
					return (1D - Math.Cos (((pdAngle * Math.PI) / 180D)));
				}
				else
				{
					return 2D;
				}
			}
			
			public void Clear ()
			
			{
				this.m_lstInstructions.Clear ();
				this.objIndex = -1;
			}
			
			public void JobCommandsToObject (ArrayList jobCommands)
			
			{
				foreach (AtCommand atCommand1 in jobCommands)
				{
					int i1 = this.m_lstInstructions.Add (atCommand1);
				}
			}
			
			private void ProcessCommands ()
			
			{
				AtCommand atCommand2;
				uint uInt32_1;
				short int16_6;
				short int16_7;
				short int16_8;
				double double2;
				double double3;
				int i3;
				LECOpcodes lECOpcodes1;
				IDisposable iDisposable1;
				short int16_1 = 0;
				short int16_2 = 0;
				bool b1 = false;
				short int16_3 = 0;
				short int16_4 = 0;
				short int16_5 = 0;
				bool b2 = false;
				ArrayList arrayList1 = new ArrayList ();
				AtCommand atCommand1 = ((AtCommand) null);
				double double1 = 0D;
				int i1 = 1;
				int i2 = 0;
				IEnumerator iEnumerator1 = this.m_lstInstructions.GetEnumerator ();
				try
				{
					goto L_03F6;
					
				L_0287:
					
					{
					}
					if (atCommand2.Opcode != LECOpcodes.JumpAbs)
					{
						int i9 = atCommand2.Parameters.Add (int16_2);
					}
					else if (((uInt32_1 != uint.MinValue) && b1) && (((short) uInt32_1) < int16_3))
					{
						int i7 = atCommand2.Parameters.Add (((short) (((long) uInt32_1) * ((long) ((int16_1 - int16_4) / int16_3)))));
					}
					else
					{
						int i8 = atCommand2.Parameters.Add (int16_1);
					}
					atCommand1 = atCommand2;
					i1++;
					goto L_03F0;
					
				L_03DD:
					
					{
					}
					atCommand2.Parameters.Insert (0, 0);
					
				L_03F0:
					
					{
					}
					i2++;
					
				L_03F6:
					
					{
					}
					while (iEnumerator1.MoveNext ())
					{
						atCommand2 = ((AtCommand) iEnumerator1.Current);
						lECOpcodes1 = atCommand2.Opcode;
						if (lECOpcodes1 > LECOpcodes.SetMotfCalFactor)
						{
							if (lECOpcodes1 == LECOpcodes.WaitForMotfCount)
							{
								goto L_03DD;
							}
							if ((lECOpcodes1 != LECOpcodes.JumpAbs) && (lECOpcodes1 != LECOpcodes.MarkAbs))
							{
								goto L_03F0;
							}
							uInt32_1 = uint.MinValue;
							if (atCommand1 != null)
							{
								uInt32_1 = ((uint) this.CalcLength (((short) atCommand1.Parameters[0]), ((short) atCommand1.Parameters[1]), ((short) atCommand2.Parameters[0]), ((short) atCommand2.Parameters[1])));
							}
							if (atCommand2.Opcode == LECOpcodes.JumpAbs)
							{
								atCommand1 = ((AtCommand) null);
								double1 = 0D;
								i1 = 1;
							}
							if (atCommand2.Parameters.Count == 2)
							{
								int16_6 = 0;
								int i4 = atCommand2.Parameters.Add (int16_6);
							}
							int16_7 = 0;
							int16_8 = 0;
							if (uInt32_1 > uint.MinValue)
							{
								int16_7 = ((short) ((((int) uInt32_1) & -65536) >> 16));
								int16_8 = ((short) (((int) uInt32_1) & 65535));
							}
							int i5 = atCommand2.Parameters.Add (int16_8);
							int i6 = atCommand2.Parameters.Add (int16_7);
							if (atCommand1 != null)
							{
								if (! b2)
								{
									if (i1 > 2)
									{
										atCommand1.Parameters[5] = int16_5;
									}
									goto L_0287;
								}
								double2 = this.CalcAngle (((short) atCommand1.Parameters[0]), ((short) atCommand1.Parameters[1]), ((short) atCommand2.Parameters[0]), ((short) atCommand2.Parameters[1]));
								if (i1 > 2)
								{
									double3 = ((double1 > double2) ? (double1 - double2) : (double2 - double1));
									if (double3 > 180D)
									{
										double3 -= 180D;
									}
									atCommand1.Parameters[5] = ((short) (this.CalcScaleDelay (double3) * ((double) int16_5)));
								}
								double1 = double2;
							}
							goto L_0287;
						}
						else
						{
							switch (lECOpcodes1)
							{
								case LECOpcodes.SetPolyDelay:
								
								{
										int16_5 = ((short) atCommand2.Parameters[0]);
										int i10 = arrayList1.Add (i2);
										goto L_03F0;
								}
								case LECOpcodes.SetVariPolyDelayFlag:
								
								{
										b2 = (((short) atCommand2.Parameters[0]) != 0);
										int i11 = arrayList1.Add (i2);
										goto L_03F0;
								}
								case LECOpcodes.SetJumpDelay:
								
								{
										int16_1 = ((short) atCommand2.Parameters[0]);
										int i12 = arrayList1.Add (i2);
										goto L_03F0;
								}
								case LECOpcodes.SetVariJumpDelay:
								
								{
										int16_4 = ((short) atCommand2.Parameters[0]);
										int16_3 = ((short) atCommand2.Parameters[1]);
										b1 = (int16_3 != 0);
										int i13 = arrayList1.Add (i2);
										goto L_03F0;
								}
								case LECOpcodes.SetMarkDelay:
								
								{
										int16_2 = ((short) atCommand2.Parameters[0]);
										int i14 = arrayList1.Add (i2);
										goto L_03F0;
								}
								case LECOpcodes.LaserOn:
								case LECOpcodes.LongDelay:
								
								{
										goto L_03DD;
								}
							}
							if (lECOpcodes1 == LECOpcodes.SetMotfCalFactor)
							{
								goto L_03DD;
							}
							else
							{
								goto L_03F0;
							}
						}
					}
				}
				finally
				{
					iDisposable1 = (iEnumerator1 as IDisposable);
					if (iDisposable1 != null)
					{
						iDisposable1.Dispose ();
					}
				}
				for (i3 = arrayList1.Count; (i3 != 0); i3--)
				{
					this.m_lstInstructions.RemoveAt (((int) arrayList1[((int) (i3 - 1))]));
				}
				this.m_bProcessCommands = true;
			}
			
			public byte[] ToBytes ()
			
			{
				byte[] byteArray1;
				ArrayList arrayList1 = new ArrayList ();
				ArrayList arrayList2 = this.ToCommands ();
				int i1 = 0;
				foreach (AtCommand atCommand1 in arrayList2)
				{
					byteArray1 = atCommand1.ToBytes ();
					i1 += byteArray1.Length;
					int i3 = arrayList1.Add (byteArray1);
				}
				byte[] byteArray2 = new byte[i1];
				int i2 = 0;
				foreach (byte[] byteArray3 in arrayList1)
				{
					Array.Copy (((Array) byteArray3), 0, ((Array) byteArray2), i2, byteArray3.Length);
					i2 += byteArray3.Length;
				}
				return byteArray2;
			}
			
			public ArrayList ToCommands ()
			
			{
				ArrayList arrayList1 = new ArrayList ();
				if (! this.m_bProcessCommands)
				{
					this.ProcessCommands ();
				}
				foreach (AtCommand atCommand1 in this.m_lstInstructions)
				{
					int i1 = arrayList1.Add (atCommand1);
				}
				return arrayList1;
			}
			
		#endregion
	}
	
}

