//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:30:26
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace OpenNETCF.Diagnostics

{
		
		#region Namespace Import Declarations
		
			using System.Diagnostics;
			using System.IO;
			using System;
			
		#endregion
		
	public class TextWriterTraceListener : TraceListener
	
	{
		
		#region Fields
			private TextWriter writer;
		#endregion
		
		#region Constructors
		
			public TextWriterTraceListener ()
				 : base ("TextWriter")
			
			{
			}
			
			
			public TextWriterTraceListener (Stream stream)
				 : this (stream, string.Empty)
			
			{
			}
			
			
			public TextWriterTraceListener (Stream stream, string name)
				 : base (name)
			
			{
				if (stream == null)
				{
					throw new ArgumentNullException ("stream");
				}
				else
				{
					this.writer = ((TextWriter) new StreamWriter (stream));
				}
			}
			
			
			public TextWriterTraceListener (TextWriter writer)
				 : this (writer, string.Empty)
			
			{
			}
			
			
			public TextWriterTraceListener (TextWriter writer, string name)
				 : base (name)
			
			{
				if (writer == null)
				{
					throw new ArgumentNullException ("writer");
				}
				else
				{
					this.writer = writer;
				}
			}
			
			
			public TextWriterTraceListener (string fileName)
				 : this (((TextWriter) new StreamWriter (fileName, true)))
			
			{
			}
			
			
			public TextWriterTraceListener (string fileName, string name)
				 : this (((TextWriter) new StreamWriter (fileName, true)), name)
			
			{
			}
			
		#endregion
		
		#region Properties
		
			public TextWriter Writer
			
			{
				get
				{
					return this.writer;
				}
				set
				{
					this.writer = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			public override void Close ()
			
			{
				if (this.writer != null)
				{
					this.writer.Close ();
				}
			}
			
			protected void Dispose (bool disposing)
			
			{
				if (disposing)
				{
					this.Close ();
				}
			}
			
			public override void Flush ()
			
			{
				if (this.writer != null)
				{
					this.writer.Flush ();
				}
			}
			
			public override void Write (string message)
			
			{
				if (this.writer != null)
				{
					if (base.NeedIndent)
					{
						this.WriteIndent ();
					}
					this.writer.Write (message);
				}
			}
			
			public override void WriteLine (string message)
			
			{
				if (this.writer != null)
				{
					if (base.NeedIndent)
					{
						this.WriteIndent ();
					}
					this.writer.WriteLine (message);
					base.NeedIndent = true;
				}
			}
			
		#endregion
	}
	
}

