//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:30:26
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace OpenNETCF.Diagnostics

{
		
		#region Namespace Import Declarations
		
			using System.Collections;
			using System.Diagnostics;
			using System;
			using System.Reflection;
			
		#endregion
		
	internal class TraceInternalEx
	
	{
		
		#region Fields
			internal static string appBase;
			private static bool autoFlush;
			private static int indentLevel;
			private static int indentSize;
			private static TraceListenerCollection listeners;
			private static bool settingsInitialized;
		#endregion
		
		#region Constructors
		
			static TraceInternalEx ()
			
			{
				TraceInternalEx.autoFlush = true;
				TraceInternalEx.settingsInitialized = false;
				TraceInternalEx.appBase = string.Empty;
			}
			
			
			public TraceInternalEx ()
			
			{
			}
			
		#endregion
		
		#region Properties
		
			public static bool AutoFlush
			
			{
				get
				{
					if (! TraceInternalEx.settingsInitialized)
					{
						TraceInternalEx.InitializeSettings ();
					}
					return TraceInternalEx.autoFlush;
				}
				set
				{
					if (! TraceInternalEx.settingsInitialized)
					{
						TraceInternalEx.InitializeSettings ();
					}
					TraceInternalEx.autoFlush = value;
				}
			}
			
			
			public static int IndentLevel
			
			{
				get
				{
					if (! TraceInternalEx.settingsInitialized)
					{
						TraceInternalEx.InitializeSettings ();
					}
					return TraceInternalEx.indentLevel;
				}
				set
				{
					if (! TraceInternalEx.settingsInitialized)
					{
						TraceInternalEx.InitializeSettings ();
					}
					if (value < 0)
					{
						value = 0;
					}
					TraceInternalEx.indentLevel = value;
					foreach (TraceListener traceListener1 in TraceInternalEx.Listeners)
					{
						traceListener1.IndentLevel = TraceInternalEx.indentLevel;
					}
				}
			}
			
			
			public static int IndentSize
			
			{
				get
				{
					if (! TraceInternalEx.settingsInitialized)
					{
						TraceInternalEx.InitializeSettings ();
					}
					return TraceInternalEx.indentSize;
				}
				set
				{
					if (! TraceInternalEx.settingsInitialized)
					{
						TraceInternalEx.InitializeSettings ();
					}
					TraceInternalEx.SetIndentSize (value);
				}
			}
			
			
			public static TraceListenerCollection Listeners
			
			{
				get
				{
					if (! TraceInternalEx.settingsInitialized)
					{
						TraceInternalEx.InitializeSettings ();
					}
					if (TraceInternalEx.listeners != null)
					{
						return TraceInternalEx.listeners;
					}
					Type type1 = Type.GetType ("System.Diagnostics.TraceListenerCollection, System, Version0x03d1.0.5000.0, Culture0x03d"
					+ "neutral, PublicKeyToken0x03d969db8053d3322ac");
					if (type1 == null)
					{
						return null;
					}
					ConstructorInfo constructorInfo1 = type1.GetConstructor ((BindingFlags.Instance | BindingFlags.NonPublic), ((Binder) null), new Type[0], ((ParameterModifier[]) null));
					if (constructorInfo1 == null)
					{
						return null;
					}
					TraceInternalEx.listeners = ((TraceListenerCollection) constructorInfo1.Invoke (new object[0]));
					TraceListener traceListener1 = ((TraceListener) new DefaultTraceListener ());
					traceListener1.IndentLevel = TraceInternalEx.indentLevel;
					traceListener1.IndentSize = TraceInternalEx.indentSize;
					int i1 = TraceInternalEx.listeners.Add (traceListener1);
					return TraceInternalEx.listeners;
				}
			}
			
		#endregion
		
		#region Methods
		
			public static void Assert (bool condition)
			
			{
				if (! condition)
				{
					TraceInternalEx.Fail (string.Empty, ((string) null));
				}
			}
			
			public static void Assert (bool condition, string message, string detailMessage)
			
			{
				if (! condition)
				{
					TraceInternalEx.Fail (message, detailMessage);
				}
			}
			
			public static void Assert (bool condition, string message)
			
			{
				if (! condition)
				{
					TraceInternalEx.Fail (message, ((string) null));
				}
			}
			
			internal static int AssertFailure (string File, int Line, string Expr)
			
			{
				Type type1 = Type.GetType ("System.Diagnostics.TraceInternal, System");
				if (type1 == null)
				{
					return -1;
				}
				MethodInfo methodInfo1 = type1.GetMethod ("AssertFailure", (BindingFlags.Static | BindingFlags.NonPublic));
				if (methodInfo1 == null)
				{
					return -1;
				}
				object[] objectArray1 = new object[] { File, Line, Expr };
				return ((int) methodInfo1.Invoke (null, objectArray1));
			}
			
			public static void Close ()
			
			{
				if (TraceInternalEx.listeners != null)
				{
					foreach (TraceListener traceListener1 in TraceInternalEx.Listeners)
					{
						traceListener1.Close ();
					}
				}
			}
			
			public static void Fail (string message)
			
			{
				TraceInternalEx.Fail (message, ((string) null));
			}
			
			public static void Fail (string message, string detailMessage)
			
			{
				string string1 = message;
				if (detailMessage != null)
				{
					string1 = (string1 + "\r\n\r\n" + detailMessage);
				}
				int i1 = TraceInternalEx.AssertFailure ("managed code", 0, string1);
			}
			
			public static void Flush ()
			
			{
				if (TraceInternalEx.listeners != null)
				{
					foreach (TraceListener traceListener1 in TraceInternalEx.Listeners)
					{
						traceListener1.Flush ();
					}
				}
			}
			
			public static void Indent ()
			
			{
				if (! TraceInternalEx.settingsInitialized)
				{
					TraceInternalEx.InitializeSettings ();
				}
				TraceInternalEx.indentLevel++;
				foreach (TraceListener traceListener1 in TraceInternalEx.Listeners)
				{
					traceListener1.IndentLevel = TraceInternalEx.indentLevel;
				}
			}
			
			internal static void InitializeSettings ()
			
			{
				DiagnosticsConfiguration.AppBase = TraceInternalEx.appBase;
				TraceInternalEx.SetIndentSize (DiagnosticsConfiguration.IndentSize);
				TraceInternalEx.autoFlush = DiagnosticsConfiguration.AutoFlush;
				TraceInternalEx.settingsInitialized = true;
			}
			
			private static void SetIndentSize (int value)
			
			{
				if (value < 0)
				{
					value = 0;
				}
				TraceInternalEx.indentSize = value;
				if (TraceInternalEx.listeners != null)
				{
					foreach (TraceListener traceListener1 in TraceInternalEx.Listeners)
					{
						traceListener1.IndentSize = TraceInternalEx.indentSize;
					}
				}
			}
			
			public static void Unindent ()
			
			{
				if (! TraceInternalEx.settingsInitialized)
				{
					TraceInternalEx.InitializeSettings ();
				}
				if (TraceInternalEx.indentLevel > 0)
				{
					TraceInternalEx.indentLevel--;
				}
				foreach (TraceListener traceListener1 in TraceInternalEx.Listeners)
				{
					traceListener1.IndentLevel = TraceInternalEx.indentLevel;
				}
			}
			
			public static void Write (string message)
			
			{
				foreach (TraceListener traceListener1 in TraceInternalEx.Listeners)
				{
					traceListener1.Write (message);
					if (TraceInternalEx.autoFlush)
					{
						traceListener1.Flush ();
					}
				}
			}
			
			public static void Write (object value)
			
			{
				foreach (TraceListener traceListener1 in TraceInternalEx.Listeners)
				{
					traceListener1.Write (value);
					if (TraceInternalEx.autoFlush)
					{
						traceListener1.Flush ();
					}
				}
			}
			
			public static void Write (string message, string category)
			
			{
				foreach (TraceListener traceListener1 in TraceInternalEx.Listeners)
				{
					traceListener1.Write (message, category);
					if (TraceInternalEx.autoFlush)
					{
						traceListener1.Flush ();
					}
				}
			}
			
			public static void Write (object value, string category)
			
			{
				foreach (TraceListener traceListener1 in TraceInternalEx.Listeners)
				{
					traceListener1.Write (value, category);
					if (TraceInternalEx.autoFlush)
					{
						traceListener1.Flush ();
					}
				}
			}
			
			public static void WriteLine (object value, string category)
			
			{
				foreach (TraceListener traceListener1 in TraceInternalEx.Listeners)
				{
					traceListener1.WriteLine (value, category);
					if (TraceInternalEx.autoFlush)
					{
						traceListener1.Flush ();
					}
				}
			}
			
			public static void WriteLine (string message)
			
			{
				foreach (TraceListener traceListener1 in TraceInternalEx.Listeners)
				{
					traceListener1.WriteLine (message);
					if (TraceInternalEx.autoFlush)
					{
						traceListener1.Flush ();
					}
				}
			}
			
			public static void WriteLine (object value)
			
			{
				foreach (TraceListener traceListener1 in TraceInternalEx.Listeners)
				{
					traceListener1.WriteLine (value);
					if (TraceInternalEx.autoFlush)
					{
						traceListener1.Flush ();
					}
				}
			}
			
			public static void WriteLine (string message, string category)
			
			{
				foreach (TraceListener traceListener1 in TraceInternalEx.Listeners)
				{
					traceListener1.WriteLine (message, category);
					if (TraceInternalEx.autoFlush)
					{
						traceListener1.Flush ();
					}
				}
			}
			
		#endregion
	}
	
}

