//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:30:26
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace OpenNETCF.Runtime.InteropServices

{
		
		#region Namespace Import Declarations
		
			using System;
			using System.Collections;
			using System.IO;
			using System.Reflection;
			using System.Runtime.InteropServices;
			using System.Text;
			
		#endregion
		
	public abstract class AdvancedMarshaler
	
	{
		
		#region Fields
			private BinaryReader binReader;
			private BinaryWriter binWriter;
			internal byte[] data;
			private MemoryStream stream;
		#endregion
		
		#region Constructors
		
			public AdvancedMarshaler ()
			
			{
			}
			
		#endregion
		
		#region Properties
		
			public byte[] ByteArray
			
			{
				get
				{
					return this.data;
				}
			}
			
		#endregion
		
		#region Methods
		
			private static bool CompareByteArrays (byte[] data1, byte[] data2)
			
			{
				int i1;
				if ((data1 == null) && (data2 == null))
				{
					return true;
				}
				else if ((data1 == null) || (data2 == null))
				{
					return false;
				}
				else if (data1.Length != data2.Length)
				{
					return false;
				}
				else
				{
					for (i1 = 0; (i1 < data1.Length); i1++)
					{
						if (data1[i1] != data2[i1])
						{
							return false;
						}
					}
					return true;
				}
			}
			
			public void Deserialize ()
			
			{
				if (this.data != null)
				{
					if (this.binReader != null)
					{
						this.binReader.Close ();
						this.stream.Close ();
					}
					this.stream = new MemoryStream (this.data);
					this.binReader = new BinaryReader (((Stream) this.stream), Encoding.Unicode);
					this.ReadFromStream (this.binReader);
					this.binReader.Close ();
				}
			}
			
			protected int GetFieldSize (FieldInfo field)
			
			{
				FieldInfo fieldInfo1;
				int i1 = 0;
				CustomMarshalAsAttribute customMarshalAsAttribute1 = ((CustomMarshalAsAttribute) field.GetCustomAttributes (typeof (CustomMarshalAsAttribute), true)[0]);
				if (customMarshalAsAttribute1 == null)
				{
					return i1;
				}
				else if (customMarshalAsAttribute1.SizeField != null)
				{
					fieldInfo1 = base.GetType ().GetField (customMarshalAsAttribute1.SizeField);
					return ((int) fieldInfo1.GetValue (this));
				}
				else
				{
					return customMarshalAsAttribute1.SizeConst;
				}
			}
			
			public int GetSize ()
			
			{
				int i1 = 0;
				foreach (FieldInfo fieldInfo1 in base.GetType ().GetFields ((BindingFlags.Instance | BindingFlags.Public)))
				{
					if (fieldInfo1.FieldType.IsArray)
					{
						i1 += this.GetFieldSize (fieldInfo1);
					}
					else if (fieldInfo1.FieldType == typeof (string))
					{
						i1 += (this.GetFieldSize (fieldInfo1) * 2);
					}
					else if (fieldInfo1.FieldType.IsPrimitive)
					{
						i1 += Marshal.SizeOf (fieldInfo1.FieldType);
					}
				}
				return i1;
			}
			
			public virtual void ReadFromStream (BinaryReader reader)
			
			{
				MethodInfo methodInfo1;
				Type type1;
				int i1;
				Array array1;
				int i2;
				AdvancedMarshaler advancedMarshaler1;
				object[] objectArray2;
				object[] objectArray1 = ((object[]) null);
				foreach (FieldInfo fieldInfo1 in base.GetType ().GetFields ((BindingFlags.Instance | BindingFlags.Public)))
				{
					methodInfo1 = ((MethodInfo) MarshallingMethods.ReadMethods[fieldInfo1.FieldType]);
					if (fieldInfo1.FieldType.IsArray)
					{
						type1 = fieldInfo1.FieldType.GetElementType ();
						if ((! type1.IsValueType) || (! type1.IsPrimitive))
						{
							i1 = this.GetFieldSize (fieldInfo1);
							methodInfo1 = ((MethodInfo) MarshallingMethods.ReadMethods[typeof (AdvancedMarshaler)]);
							array1 = Array.CreateInstance (type1, i1);
							for (i2 = 0; (i2 < i1); i2++)
							{
								array1.SetValue (Activator.CreateInstance (type1), i2);
								objectArray2 = new object[] { reader };
								object object1 = methodInfo1.Invoke (array1.GetValue (i2), objectArray2);
							}
							fieldInfo1.SetValue (this, array1);
						}
						else if ((type1 != typeof (char)) && (type1 != typeof (byte)))
						{
							objectArray1 = new object[] { reader, this.GetFieldSize (fieldInfo1) };
							fieldInfo1.SetValue (this, methodInfo1.Invoke (null, objectArray1));
						}
						else
						{
							objectArray1 = new object[] { this.GetFieldSize (fieldInfo1) };
							fieldInfo1.SetValue (this, methodInfo1.Invoke (reader, objectArray1));
						}
					}
					else if (fieldInfo1.FieldType == typeof (string))
					{
						objectArray1 = new object[] { reader, this.GetFieldSize (fieldInfo1) };
						fieldInfo1.SetValue (this, methodInfo1.Invoke (null, objectArray1));
					}
					else if ((! fieldInfo1.FieldType.IsValueType) || (! fieldInfo1.FieldType.IsPrimitive))
					{
						advancedMarshaler1 = ((AdvancedMarshaler) Activator.CreateInstance (fieldInfo1.FieldType));
						advancedMarshaler1.ReadFromStream (reader);
					}
					else
					{
						fieldInfo1.SetValue (this, methodInfo1.Invoke (reader, ((object[]) null)));
					}
				}
			}
			
			public void Serialize ()
			
			{
				if (this.data != null)
				{
					this.stream = new MemoryStream (this.data);
					this.binWriter = new BinaryWriter (((Stream) this.stream), Encoding.Unicode);
					this.WriteToStream (this.binWriter);
					this.binWriter.Close ();
				}
			}
			
			public virtual void WriteToStream (BinaryWriter writer)
			
			{
				object object1;
				MethodInfo methodInfo1;
				Type type1;
				Array array1;
				int i1;
				Array array2;
				int i2;
				object[] objectArray2;
				object[] objectArray1 = ((object[]) null);
				foreach (FieldInfo fieldInfo1 in base.GetType ().GetFields ((BindingFlags.Instance | BindingFlags.Public)))
				{
					object1 = fieldInfo1.GetValue (this);
					methodInfo1 = ((MethodInfo) MarshallingMethods.WriteMethods[fieldInfo1.FieldType]);
					if (fieldInfo1.FieldType.IsArray)
					{
						type1 = fieldInfo1.FieldType.GetElementType ();
						if ((! type1.IsValueType) || (! type1.IsPrimitive))
						{
							i1 = this.GetFieldSize (fieldInfo1);
							methodInfo1 = ((MethodInfo) MarshallingMethods.WriteMethods[typeof (AdvancedMarshaler)]);
							array2 = ((Array) fieldInfo1.GetValue (this));
							for (i2 = 0; (i2 < i1); i2++)
							{
								objectArray2 = new object[] { writer };
								object object3 = methodInfo1.Invoke (array2.GetValue (i2), objectArray2);
							}
						}
						else
						{
							array1 = ((Array) fieldInfo1.GetValue (this));
							objectArray1 = new object[] { writer, array1 };
							object object2 = methodInfo1.Invoke (null, objectArray1);
						}
					}
					else if (fieldInfo1.FieldType == typeof (string))
					{
						objectArray1 = new object[] { writer, fieldInfo1.GetValue (this), this.GetFieldSize (fieldInfo1) };
						object object4 = methodInfo1.Invoke (null, objectArray1);
					}
					else if (fieldInfo1.FieldType.IsValueType && fieldInfo1.FieldType.IsPrimitive)
					{
						objectArray2 = new object[] { object1 };
						object object5 = methodInfo1.Invoke (writer, objectArray2);
					}
				}
			}
			
		#endregion
	}
	
}

