//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:22:16
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LECHardwareAbstraction.SerialPortInterface

{
		
		#region Namespace Import Declarations
		
			using System;
			using System.Runtime.InteropServices;
			using System.Text;
			
		#endregion
		
	[System.Runtime.InteropServices.StructLayout(LayoutKind.Sequential, Pack = 8, CharSet = CharSet.Ansi)]
	internal class DCB
	
	{
		
		#region Fields
			private uint DCBlength;
			public uint BaudRate;
			internal uint Control;
			internal UInt16 wReserved;
			public UInt16 XonLim;
			public UInt16 XoffLim;
			public byte ByteSize;
			public byte Parity;
			public byte StopBits;
			public sbyte XonChar;
			public sbyte XoffChar;
			public sbyte ErrorChar;
			public sbyte EofChar;
			public sbyte EvtChar;
			internal UInt16 wReserved1;
			private readonly uint fBinaryMask;
			private readonly int fBinaryShift;
			private readonly uint fParityMask;
			private readonly int fParityShift;
			private readonly uint fOutxCtsFlowMask;
			private readonly int fOutxCtsFlowShift;
			private readonly uint fOutxDsrFlowMask;
			private readonly int fOutxDsrFlowShift;
			private readonly uint fDtrControlMask;
			private readonly int fDtrControlShift;
			private readonly uint fDsrSensitivityMask;
			private readonly int fDsrSensitivityShift;
			private readonly uint fTXContinueOnXoffMask;
			private readonly int fTXContinueOnXoffShift;
			private readonly uint fOutXMask;
			private readonly int fOutXShift;
			private readonly uint fInXMask;
			private readonly int fInXShift;
			private readonly uint fErrorCharMask;
			private readonly int fErrorCharShift;
			private readonly uint fNullMask;
			private readonly int fNullShift;
			private readonly uint fRtsControlMask;
			private readonly int fRtsControlShift;
			private readonly uint fAbortOnErrorMask;
			private readonly int fAbortOnErrorShift;
		#endregion
		
		#region Nested Types
		
			public enum DtrControlFlags : byte
			
			{
				Disable = byte.MinValue, 
				Enable = 1, 
				Handshake = 2, 
			}
			
			
			public enum RtsControlFlags : byte
			
			{
				Disable = byte.MinValue, 
				Enable = 1, 
				Handshake = 2, 
				Toggle = 3, 
			}
			
		#endregion
		
		#region Constructors
		
			public DCB ()
			
			{
				this.fBinaryMask = 1;
				this.fBinaryShift = 0;
				this.fParityMask = 2;
				this.fParityShift = 1;
				this.fOutxCtsFlowMask = 4;
				this.fOutxCtsFlowShift = 2;
				this.fOutxDsrFlowMask = 8;
				this.fOutxDsrFlowShift = 3;
				this.fDtrControlMask = 48;
				this.fDtrControlShift = 4;
				this.fDsrSensitivityMask = 64;
				this.fDsrSensitivityShift = 6;
				this.fTXContinueOnXoffMask = 128;
				this.fTXContinueOnXoffShift = 7;
				this.fOutXMask = 256;
				this.fOutXShift = 8;
				this.fInXMask = 512;
				this.fInXShift = 9;
				this.fErrorCharMask = 1024;
				this.fErrorCharShift = 10;
				this.fNullMask = 2048;
				this.fNullShift = 11;
				this.fRtsControlMask = 12288;
				this.fRtsControlShift = 12;
				this.fAbortOnErrorMask = 16384;
				this.fAbortOnErrorShift = 14;
				this.DCBlength = ((uint) Marshal.SizeOf (this));
			}
			
		#endregion
		
		#region Properties
		
			public bool fBinary
			
			{
				get
				{
					return ((this.Control & this.fBinaryMask) != uint.MinValue);
				}
				set
				{
					this.Control |= ((uint) (Convert.ToUInt32 (value) << (this.fBinaryShift & 31)));
				}
			}
			
			
			public bool fParity
			
			{
				get
				{
					return ((this.Control & this.fParityMask) != uint.MinValue);
				}
				set
				{
					this.Control |= ((uint) (Convert.ToUInt32 (value) << (this.fParityShift & 31)));
				}
			}
			
			
			public bool fOutxCtsFlow
			
			{
				get
				{
					return ((this.Control & this.fOutxCtsFlowMask) != uint.MinValue);
				}
				set
				{
					this.Control |= ((uint) (Convert.ToUInt32 (value) << (this.fOutxCtsFlowShift & 31)));
				}
			}
			
			
			public bool fOutxDsrFlow
			
			{
				get
				{
					return ((this.Control & this.fOutxDsrFlowMask) != uint.MinValue);
				}
				set
				{
					this.Control |= ((uint) (Convert.ToUInt32 (value) << (this.fOutxDsrFlowShift & 31)));
				}
			}
			
			
			public DtrControlFlags fDtrControl
			
			{
				get
				{
					return ((DtrControlFlags) ((byte) ((this.Control & this.fDtrControlMask) >> (this.fDtrControlShift & 31))));
				}
				set
				{
					this.Control |= ((uint) (Convert.ToUInt32 (value) << (this.fDtrControlShift & 31)));
				}
			}
			
			
			public bool fDsrSensitivity
			
			{
				get
				{
					return ((this.Control & this.fDsrSensitivityMask) != uint.MinValue);
				}
				set
				{
					this.Control |= ((uint) (Convert.ToUInt32 (value) << (this.fDsrSensitivityShift & 31)));
				}
			}
			
			
			public bool fTXContinueOnXoff
			
			{
				get
				{
					return ((this.Control & this.fTXContinueOnXoffMask) != uint.MinValue);
				}
				set
				{
					this.Control |= ((uint) (Convert.ToUInt32 (value) << (this.fTXContinueOnXoffShift & 31)));
				}
			}
			
			
			public bool fOutX
			
			{
				get
				{
					return ((this.Control & this.fOutXMask) != uint.MinValue);
				}
				set
				{
					this.Control |= ((uint) (Convert.ToUInt32 (value) << (this.fOutXShift & 31)));
				}
			}
			
			
			public bool fInX
			
			{
				get
				{
					return ((this.Control & this.fInXMask) != uint.MinValue);
				}
				set
				{
					this.Control |= ((uint) (Convert.ToUInt32 (value) << (this.fInXShift & 31)));
				}
			}
			
			
			public bool fErrorChar
			
			{
				get
				{
					return ((this.Control & this.fErrorCharMask) != uint.MinValue);
				}
				set
				{
					this.Control |= ((uint) (Convert.ToUInt32 (value) << (this.fErrorCharShift & 31)));
				}
			}
			
			
			public bool fNull
			
			{
				get
				{
					return ((this.Control & this.fNullMask) != uint.MinValue);
				}
				set
				{
					this.Control |= ((uint) (Convert.ToUInt32 (value) << (this.fNullShift & 31)));
				}
			}
			
			
			public RtsControlFlags fRtsControl
			
			{
				get
				{
					return ((RtsControlFlags) ((byte) ((this.Control & this.fRtsControlMask) >> (this.fRtsControlShift & 31))));
				}
				set
				{
					this.Control |= ((uint) (Convert.ToUInt32 (value) << (this.fRtsControlShift & 31)));
				}
			}
			
			
			public bool fAbortOnError
			
			{
				get
				{
					return ((this.Control & this.fAbortOnErrorMask) != uint.MinValue);
				}
				set
				{
					this.Control |= ((uint) (Convert.ToUInt32 (value) << (this.fAbortOnErrorShift & 31)));
				}
			}
			
		#endregion
		
		#region Methods
		
			internal void _SuppressCompilerWarnings ()
			
			{
				this.wReserved = this.wReserved;
				this.wReserved1 = this.wReserved1;
			}
			
			public override string ToString ()
			
			{
				StringBuilder stringBuilder1 = new StringBuilder ();
				StringBuilder stringBuilder2 = stringBuilder1.Append ("DCB:\r\n");
				object[] objectArray1 = new object[] { this.BaudRate };
				StringBuilder stringBuilder3 = stringBuilder1.AppendFormat (((IFormatProvider) null), "  BaudRate:     {0}\r\n", objectArray1);
				objectArray1 = new object[] { this.Control };
				StringBuilder stringBuilder4 = stringBuilder1.AppendFormat (((IFormatProvider) null), "  Control:      0x{0:x}\r\n", objectArray1);
				objectArray1 = new object[] { this.fBinary };
				StringBuilder stringBuilder5 = stringBuilder1.AppendFormat (((IFormatProvider) null), "    fBinary:           {0}\r\n", objectArray1);
				objectArray1 = new object[] { this.fParity };
				StringBuilder stringBuilder6 = stringBuilder1.AppendFormat (((IFormatProvider) null), "    fParity:           {0}\r\n", objectArray1);
				objectArray1 = new object[] { this.fOutxCtsFlow };
				StringBuilder stringBuilder7 = stringBuilder1.AppendFormat (((IFormatProvider) null), "    fOutxCtsFlow:      {0}\r\n", objectArray1);
				objectArray1 = new object[] { this.fOutxDsrFlow };
				StringBuilder stringBuilder8 = stringBuilder1.AppendFormat (((IFormatProvider) null), "    fOutxDsrFlow:      {0}\r\n", objectArray1);
				objectArray1 = new object[] { this.fDtrControl };
				StringBuilder stringBuilder9 = stringBuilder1.AppendFormat (((IFormatProvider) null), "    fDtrControl:       {0}\r\n", objectArray1);
				objectArray1 = new object[] { this.fDsrSensitivity };
				StringBuilder stringBuilder10 = stringBuilder1.AppendFormat (((IFormatProvider) null), "    fDsrSensitivity:   {0}\r\n", objectArray1);
				objectArray1 = new object[] { this.fTXContinueOnXoff };
				StringBuilder stringBuilder11 = stringBuilder1.AppendFormat (((IFormatProvider) null), "    fTXContinueOnXoff: {0}\r\n", objectArray1);
				objectArray1 = new object[] { this.fOutX };
				StringBuilder stringBuilder12 = stringBuilder1.AppendFormat (((IFormatProvider) null), "    fOutX:             {0}\r\n", objectArray1);
				objectArray1 = new object[] { this.fInX };
				StringBuilder stringBuilder13 = stringBuilder1.AppendFormat (((IFormatProvider) null), "    fInX:              {0}\r\n", objectArray1);
				objectArray1 = new object[] { this.fNull };
				StringBuilder stringBuilder14 = stringBuilder1.AppendFormat (((IFormatProvider) null), "    fNull:             {0}\r\n", objectArray1);
				objectArray1 = new object[] { this.fRtsControl };
				StringBuilder stringBuilder15 = stringBuilder1.AppendFormat (((IFormatProvider) null), "    fRtsControl:       {0}\r\n", objectArray1);
				objectArray1 = new object[] { this.fAbortOnError };
				StringBuilder stringBuilder16 = stringBuilder1.AppendFormat (((IFormatProvider) null), "    fAbortOnError:     {0}\r\n", objectArray1);
				objectArray1 = new object[] { this.XonLim };
				StringBuilder stringBuilder17 = stringBuilder1.AppendFormat (((IFormatProvider) null), "  XonLim:       {0}\r\n", objectArray1);
				objectArray1 = new object[] { this.XoffLim };
				StringBuilder stringBuilder18 = stringBuilder1.AppendFormat (((IFormatProvider) null), "  XoffLim:      {0}\r\n", objectArray1);
				objectArray1 = new object[] { this.ByteSize };
				StringBuilder stringBuilder19 = stringBuilder1.AppendFormat (((IFormatProvider) null), "  ByteSize:     {0}\r\n", objectArray1);
				objectArray1 = new object[] { this.Parity };
				StringBuilder stringBuilder20 = stringBuilder1.AppendFormat (((IFormatProvider) null), "  Parity:       {0}\r\n", objectArray1);
				objectArray1 = new object[] { this.StopBits };
				StringBuilder stringBuilder21 = stringBuilder1.AppendFormat (((IFormatProvider) null), "  StopBits:     {0}\r\n", objectArray1);
				objectArray1 = new object[] { this.XonChar };
				StringBuilder stringBuilder22 = stringBuilder1.AppendFormat (((IFormatProvider) null), "  XonChar:      {0}\r\n", objectArray1);
				objectArray1 = new object[] { this.XoffChar };
				StringBuilder stringBuilder23 = stringBuilder1.AppendFormat (((IFormatProvider) null), "  XoffChar:     {0}\r\n", objectArray1);
				objectArray1 = new object[] { this.ErrorChar };
				StringBuilder stringBuilder24 = stringBuilder1.AppendFormat (((IFormatProvider) null), "  ErrorChar:    {0}\r\n", objectArray1);
				objectArray1 = new object[] { this.EofChar };
				StringBuilder stringBuilder25 = stringBuilder1.AppendFormat (((IFormatProvider) null), "  EofChar:      {0}\r\n", objectArray1);
				objectArray1 = new object[] { this.EvtChar };
				StringBuilder stringBuilder26 = stringBuilder1.AppendFormat (((IFormatProvider) null), "  EvtChar:      {0}\r\n", objectArray1);
				return stringBuilder1.ToString ();
			}
			
		#endregion
	}
	
}

