//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:22:16
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LECHardwareAbstraction.Utilities

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.LECHardwareAbstraction.PInvoke;
			using System.Net;
			using System;
			using System.Runtime.InteropServices;
			
		#endregion
		
	internal class PLI
	
	{
		
		#region Fields
			private const ulong CSC_BASE = 2962423808;
			private const ulong CSC_PWRCNT = 2962423812;
			private const ulong CSC_SYSLOCK = 2962424000;
			private const ulong GPIO_BASE = 2961440768;
			private const ulong GPIO_PADDR = 2961440784;
			private const ulong GPIO_PADR = 2961440768;
			private const ulong GPIO_PBDDR = 2961440788;
			private const ulong GPIO_PBDR = 2961440772;
			private int m_iPLIConnection;
			private string m_strMessageLog;
			private const ulong PWRCNT_USB_EN = 268435456;
			private const ulong VIRTUAL_SYSTEM_ASIC_REGS_BASE = 2952790016;
		#endregion
		
		#region Constructors
		
			public PLI ()
			
			{
				this.m_strMessageLog = "PLI - No message available.";
				this.m_iPLIConnection = -1;
			}
			
		#endregion
		
		#region Properties
		
			public int IOCTL_HAL_BOARD_RESET
			
			{
				get
				{
					return DeviceDriver.CTL_CODE (257, 76, 0, 0);
				}
			}
			
			
			public int IOCTL_HAL_WRITE_COMMON_REG
			
			{
				get
				{
					return DeviceDriver.CTL_CODE (257, 67, 0, 0);
				}
			}
			
			
			public int IOCTL_PLI_GET_IPCONFIG
			
			{
				get
				{
					return DeviceDriver.CTL_CODE (21, 2081, 0, 0);
				}
			}
			
			
			public int IOCTL_PLI_GET_TEMP
			
			{
				get
				{
					return DeviceDriver.CTL_CODE (21, 2080, 0, 0);
				}
			}
			
			
			public int IOCTL_PLI_SET_IPCONFIG
			
			{
				get
				{
					return DeviceDriver.CTL_CODE (21, 2082, 0, 0);
				}
			}
			
			
			public string MessageLog
			
			{
				get
				{
					return this.m_strMessageLog;
				}
			}
			
			
			public virtual int PLIConnection
			
			{
				get
				{
					return this.m_iPLIConnection;
				}
				set
				{
					this.m_iPLIConnection = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			public bool Connect ()
			
			{
				if (this.PLIConnection != -1)
				{
					this.m_strMessageLog = "PLI.Connect() - Already connected. Return true.";
					return true;
				}
				else
				{
					this.PLIConnection = DeviceDriver.CreateFile ("PLI1:", -1073741824, 3, IntPtr.Zero, 3, 128, 0);
					if (this.PLIConnection == -1)
					{
						this.m_strMessageLog = ("PLI.Connect() - Connection failed 0x03d " + Marshal.GetLastWin32Error ().ToString ());
						return false;
					}
					else
					{
						this.m_strMessageLog = "PLI.Connect() - Success.";
						return true;
					}
				}
			}
			
			public bool Connected ()
			
			{
				return (this.PLIConnection != -1);
			}
			
			public bool Disconnect ()
			
			{
				if (this.PLIConnection == -1)
				{
					this.m_strMessageLog = "PLI.Disconnect() - Already disconnected. Return true.";
					return true;
				}
				else
				{
					bool b1 = DeviceDriver.CloseHandle (this.PLIConnection);
					this.PLIConnection = -1;
					this.m_strMessageLog = "PLI.Disconnect() - Success.";
					return true;
				}
			}
			
			private void FromBytes (byte[] byteIPConfig, IPConfig config)
			
			{
				byte[] byteArray1 = new byte[8];
				byte[] byteArray2 = new byte[4];
				Array.Clear (((Array) byteArray1), 0, 8);
				Array.Copy (((Array) byteIPConfig), 0, ((Array) byteArray1), 0, 4);
				config.IPAddr.Address = BitConverter.ToInt64 (byteArray1, 0);
				Array.Copy (((Array) byteIPConfig), 4, ((Array) byteArray1), 0, 4);
				config.IPSubnetMask.Address = BitConverter.ToInt64 (byteArray1, 0);
				PLI_IPMode pLI_IPMode1 = ((PLI_IPMode) BitConverter.ToUInt32 (byteIPConfig, 8));
				if (PLI_IPMode.AUTO == pLI_IPMode1)
				{
					config.IPMode = DHCPModeType.Autodetect;
				}
				else if (pLI_IPMode1 == PLI_IPMode.STATIC)
				{
					config.IPMode = DHCPModeType.Static;
				}
				else
				{
					config.IPMode = DHCPModeType.Autodetect;
				}
				Array.Copy (((Array) byteIPConfig), 12, ((Array) byteArray1), 0, 4);
				config.IPGateway.Address = BitConverter.ToInt64 (byteArray1, 0);
			}
			
			public bool getIPConfig (IPConfig poConfig)
			
			{
				int i2;
				if (this.PLIConnection == -1)
				{
					this.m_strMessageLog = "PLI.getIPConfig() - Connect was not called.";
					return false;
				}
				byte[] byteArray1 = new byte[poConfig.Length];
				int i1 = 0;
				if (! DeviceDriver.DeviceIoControl (this.PLIConnection, this.IOCTL_PLI_GET_IPCONFIG, ((byte[]) null), 0, byteArray1, byteArray1.Length, ref i1, 0))
				{
					i2 = Marshal.GetLastWin32Error ();
					this.m_strMessageLog = string.Format ("PLI.IPConfig - IOCTL_PLI_GET_IPCONFIG error 0x03d {0}.", i2);
					return false;
				}
				else
				{
					this.FromBytes (byteArray1, poConfig);
					return true;
				}
			}
			
			public bool getTemperature (ref float temperature)
			
			{
				int i2;
				if (this.PLIConnection == -1)
				{
					this.m_strMessageLog = "PLI.Temperature() - Connect was not called.";
					return false;
				}
				byte[] byteArray1 = new byte[4];
				int i1 = 0;
				if (! DeviceDriver.DeviceIoControl (this.PLIConnection, this.IOCTL_PLI_GET_TEMP, ((byte[]) null), 0, byteArray1, byteArray1.Length, ref i1, 0))
				{
					i2 = Marshal.GetLastWin32Error ();
					this.m_strMessageLog = string.Format ("PLI.Temperature - IOCTL_PLI_GET_TEMPERATURE error 0x03d {0}.", i2);
					return false;
				}
				else
				{
					temperature = BitConverter.ToSingle (byteArray1, 0);
					return true;
				}
			}
			
			private bool HalWriteCommonReg (ulong pulRegister, ulong ulMask, ulong ulValue)
			
			{
				CommonRegStruct commonRegStruct1;
				int i1 = 0;
				commonRegStruct1.ulRegisterAddress = pulRegister;
				commonRegStruct1.ulMask = ulMask;
				commonRegStruct1.ulValue = ulValue;
				if ((((long) pulRegister) & ((long) (-65536))) == ((long) (-1332543488)))
				{
					commonRegStruct1.ulLockRegisterAddress = ((ulong) 0xB09300C0);
				}
				else
				{
					commonRegStruct1.ulLockRegisterAddress = ulong.MinValue;
				}
				commonRegStruct1.ulCheckSum = (((pulRegister + ulMask) + ulValue) + commonRegStruct1.ulLockRegisterAddress);
				byte[] byteArray1 = new byte[20];
				Array.Copy (((Array) BitConverter.GetBytes (((int) commonRegStruct1.ulRegisterAddress))), 0, ((Array) byteArray1), 0, 4);
				Array.Copy (((Array) BitConverter.GetBytes (((int) commonRegStruct1.ulMask))), 0, ((Array) byteArray1), 4, 4);
				Array.Copy (((Array) BitConverter.GetBytes (((int) commonRegStruct1.ulValue))), 0, ((Array) byteArray1), 8, 4);
				Array.Copy (((Array) BitConverter.GetBytes (((int) commonRegStruct1.ulLockRegisterAddress))), 0, ((Array) byteArray1), 12, 4);
				Array.Copy (((Array) BitConverter.GetBytes (((int) commonRegStruct1.ulCheckSum))), 0, ((Array) byteArray1), 16, 4);
				return DeviceDriver.KernelIoControl (this.IOCTL_HAL_WRITE_COMMON_REG, byteArray1, 20, ((byte[]) null), 0, ref i1);
			}
			
			public void ResetBoard ()
			
			{
				int i1 = 0;
				bool b1 = DeviceDriver.KernelIoControl (this.IOCTL_HAL_BOARD_RESET, ((byte[]) null), 0, ((byte[]) null), 0, ref i1);
			}
			
			public bool setIPConfig (IPConfig poConfig)
			
			{
				if (this.PLIConnection == -1)
				{
					this.m_strMessageLog = "PLI.setIPConfig() - Connect was not called.";
					return false;
				}
				byte[] byteArray1 = new byte[poConfig.Length];
				this.ToBytes (poConfig, byteArray1);
				int i1 = 0;
				if (DeviceDriver.DeviceIoControl (this.PLIConnection, this.IOCTL_PLI_SET_IPCONFIG, byteArray1, byteArray1.Length, ((byte[]) null), 0, ref i1, 0))
				{
					return true;
				}
				int i2 = Marshal.GetLastWin32Error ();
				this.m_strMessageLog = string.Format ("PLI.IPConfig - IOCTL_PLI_SET_IPCONFIG error 0x03d {0}.", i2);
				return false;
			}
			
			public void setUSBPower (bool state)
			
			{
				if (state)
				{
					bool b1 = this.HalWriteCommonReg (((ulong) 0xB0840004), 2, ulong.MinValue);
					bool b2 = this.HalWriteCommonReg (((ulong) 0xB0840014), 2, 2);
				}
				else
				{
					bool b3 = this.HalWriteCommonReg (((ulong) 0xB0840004), 2, 2);
					bool b4 = this.HalWriteCommonReg (((ulong) 0xB0840014), 2, 2);
				}
			}
			
			private void ToBytes (IPConfig Config, byte[] byteIPConfig)
			
			{
				PLI_IPMode pLI_IPMode1;
				byte[] byteArray1 = new byte[8];
				byte[] byteArray2 = new byte[4];
				byteArray1 = BitConverter.GetBytes (Config.IPAddr.Address);
				Array.Copy (((Array) byteArray1), 0, ((Array) byteIPConfig), 0, 4);
				byteArray1 = BitConverter.GetBytes (Config.IPSubnetMask.Address);
				Array.Copy (((Array) byteArray1), 0, ((Array) byteIPConfig), 4, 4);
				if (DHCPModeType.Autodetect == Config.IPMode)
				{
					pLI_IPMode1 = PLI_IPMode.AUTO;
				}
				else if (Config.IPMode == DHCPModeType.Static)
				{
					pLI_IPMode1 = PLI_IPMode.STATIC;
				}
				else
				{
					pLI_IPMode1 = PLI_IPMode.AUTO;
				}
				byteArray2 = BitConverter.GetBytes (((uint) pLI_IPMode1));
				Array.Copy (((Array) byteArray2), 0, ((Array) byteIPConfig), 8, 4);
				byteArray1 = BitConverter.GetBytes (Config.IPGateway.Address);
				Array.Copy (((Array) byteArray1), 0, ((Array) byteIPConfig), 12, 4);
			}
			
		#endregion
	}
	
}

