//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:26:05
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LocalManager.Broadcast

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.General;
			using LanmarkControls.CommonLib.Protocol;
			using LanmarkControls.LECHardwareAbstraction.Utilities;
			using LanmarkControls.LocalManager;
			using System.Collections;
			using System.Net;
			using System.Net.Sockets;
			using System;
			using System.Threading;
			using Logging = LanmarkControls.CommonLib.General.Logging;
			
		#endregion
		
	internal sealed class Broadcaster
	
	{
		
		#region Fields
			private bool enableBroadcasts;
			private IPAddress m_ipAddress;
			private int m_iPort;
			private ArrayList m_lstTransmitTime;
			private ArrayList m_lstTrigger;
			private string m_strFriendlyName;
			private string m_strHeadSerialNumber;
			public event WatchDogHandler OnKickTheDog;
			public event StatusInfoRequestHandler OnStatusInfoRequest;
			public event SystemInfoRequestHandler OnSystemInfoRequest;
		#endregion
		
		#region Constructors
		
			public Broadcaster ()
			
			{
				this.m_lstTrigger = new ArrayList ();
				this.m_lstTransmitTime = new ArrayList ();
				this.m_ipAddress = IPAddress.Parse ("224.168.100.2");
				this.m_strFriendlyName = "";
				this.m_strHeadSerialNumber = "";
				this.m_iPort = 11000;
				this.enableBroadcasts = true;
				Logging.Instance.LogConsole = false;
				Logging.Instance.LogFile = "";
				Logging.Instance.LoggingLevel = AdminSettings.OtherSettings.LoggingLevel;
				this.m_lstTransmitTime = AdminSettings.BroadcastSettings.TransmitData;
				this.m_ipAddress = AdminSettings.BroadcastSettings.Address;
				this.m_iPort = AdminSettings.BroadcastSettings.Port;
				this.m_strFriendlyName = AdminSettings.OtherSettings.FriendlyName;
				this.m_strHeadSerialNumber = AdminSettings.OtherSettings.HeadSN;
			}
			
		#endregion
		
		#region Properties
		
			public bool Enabled
			
			{
				get
				{
					return this.enableBroadcasts;
				}
				set
				{
					this.enableBroadcasts = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			private void BroadcastLoopThread ()
			
			{
				int i3;
				int i1 = this.CalcTriggerList ();
				int i2 = 0;
				this.TriggerBroadcasts (-1);
				while (true)
				{
					i3 = this.CalcShortestDuration (i2);
					Thread.Sleep (((int) (i3 * 1000)));
					i2 += i3;
					if (this.enableBroadcasts)
					{
						if (this.OnKickTheDog != null)
						{
							this.OnKickTheDog ();
						}
						this.TriggerBroadcasts (i2);
					}
					if (i2 != i1)
					{
						continue;
					}
					i2 = 0;
					this.ResetTimeIntervals ();
				}
			}
			
			private void BroadcastNow (uint puiOpcode, byte[] pbyteData, IPAddress deviceIP)
			
			{
				UdpClient udpClient1;
				IPAddress iPAddress1;
				int i1;
				ServerAdPacket serverAdPacket1;
				byte[] byteArray1;
				Exception exception1;
				try
				{
					if ((pbyteData == null) || (pbyteData.Length == 0))
					{
						return;
					}
					else
					{
						udpClient1 = new UdpClient ();
						iPAddress1 = this.m_ipAddress;
						i1 = this.m_iPort;
						serverAdPacket1 = new ServerAdPacket ();
						serverAdPacket1.Address = deviceIP;
						serverAdPacket1.RequestAddress = IPAddress.Parse ("127.0.0.1");
						serverAdPacket1.Opcode = puiOpcode;
						serverAdPacket1.Data = pbyteData;
						serverAdPacket1.DataSize = ((uint) serverAdPacket1.Data.Length);
						byteArray1 = serverAdPacket1.ToBytes ();
						udpClient1.Connect (iPAddress1, i1);
						int i2 = udpClient1.Send (byteArray1, byteArray1.Length);
						udpClient1.Close ();
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("LECStart.BroadcastNow() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
				}
			}
			
			private int CalcShortestDuration (int piCurrentTime)
			
			{
				int i1;
				int i2;
				Exception exception1;
				try
				{
					if (this.m_lstTrigger.Count == 0)
					{
						return 30;
					}
					else
					{
						i1 = 0;
						foreach (TriggerNode triggerNode1 in this.m_lstTrigger)
						{
							i2 = (triggerNode1.Interval - piCurrentTime);
							if (i1 != 0)
							{
								if (i1 > i2)
								{
									i1 = i2;
								}
								continue;
							}
							i1 = i2;
						}
						return i1;
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("LECStart.CalcShortestDuration() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
				}
				return 30;
			}
			
			private int CalcTriggerList ()
			
			{
				int i1;
				int i2;
				TransmitInfo transmitInfo1;
				TriggerNode triggerNode1;
				Exception exception1;
				IEnumerator iEnumerator1;
				IDisposable iDisposable1;
				try
				{
					if (this.m_lstTransmitTime.Count == 0)
					{
						return 5;
					}
					else
					{
						if (this.m_lstTrigger.Count > 0)
						{
							this.m_lstTrigger.Clear ();
						}
						i1 = 0;
						i2 = 0;
						iEnumerator1 = this.m_lstTransmitTime.GetEnumerator ();
						try
						{
							goto L_009B;
							
						L_0075:
							
							{
							}
							triggerNode1 = new TriggerNode (transmitInfo1.Time, transmitInfo1.Time, i2);
							int i4 = this.m_lstTrigger.Add (triggerNode1);
							i2++;
							
						L_009B:
							
							{
							}
							while (iEnumerator1.MoveNext ())
							{
								transmitInfo1 = ((TransmitInfo) iEnumerator1.Current);
								if (i1 != 0)
								{
									if ((i1 % transmitInfo1.Time) != 0)
									{
										i1 *= transmitInfo1.Time;
									}
									goto L_0075;
								}
								i1 = transmitInfo1.Time;
								goto L_0075;
							}
						}
						finally
						{
							iDisposable1 = (iEnumerator1 as IDisposable);
							if (iDisposable1 != null)
							{
								iDisposable1.Dispose ();
							}
						}
						return i1;
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("LECStart.CalcTriggerList() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
				}
				return 5;
			}
			
			private void ParseCommandLine (string[] args)
			
			{
			}
			
			private void ResetTimeIntervals ()
			
			{
				Exception exception1;
				try
				{
					if (this.m_lstTrigger.Count == 0)
					{
						return;
					}
					else
					{
						foreach (TriggerNode triggerNode1 in this.m_lstTrigger)
						{
							triggerNode1.Interval = triggerNode1.Duration;
						}
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("LECStart.ResetTimeIntervals() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
				}
			}
			
			public void Start (string[] args)
			
			{
				this.ParseCommandLine (args);
				Thread thread1 = new Thread (new ThreadStart (this.BroadcastLoopThread));
				thread1.Priority = ThreadPriority.Normal;
				thread1.Start ();
			}
			
			private void TriggerBroadcasts (int piCurrentTime)
			
			{
				SystemInfo systemInfo1;
				StatusInfo statusInfo1;
				string string1;
				Exception exception1;
				TransmitInfo transmitInfo1;
				try
				{
					this.OnSystemInfoRequest (this.m_strFriendlyName, this.m_strHeadSerialNumber, out systemInfo1);
					this.OnStatusInfoRequest (out statusInfo1);
					if (this.m_lstTrigger.Count == 0)
					{
						this.BroadcastNow (systemInfo1.Opcode, systemInfo1.Data, systemInfo1.DeviceIP);
						this.BroadcastNow (statusInfo1.Opcode, statusInfo1.Data, systemInfo1.DeviceIP);
						return;
					}
					else
					{
						foreach (TriggerNode triggerNode1 in this.m_lstTrigger)
						{
							if ((triggerNode1.Interval == piCurrentTime) || (piCurrentTime == -1))
							{
								transmitInfo1 = ((TransmitInfo) this.m_lstTransmitTime[triggerNode1.Position]);
								string1 = transmitInfo1.TransmitType;
								if (string1.CompareTo ("SysInfoData") == 0)
								{
									this.BroadcastNow (systemInfo1.Opcode, systemInfo1.Data, systemInfo1.DeviceIP);
								}
								else if (string1.CompareTo ("StatInfoData") == 0)
								{
									this.BroadcastNow (statusInfo1.Opcode, statusInfo1.Data, systemInfo1.DeviceIP);
								}
								if (piCurrentTime != -1)
								{
									triggerNode1.Interval += triggerNode1.Duration;
								}
								continue;
							}
						}
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("LECStart.TriggerBroadcasts() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
				}
			}
			
		#endregion
	}
	
}

